<template>
  <dashboard-layout title="NewSubmission" class="backG">
    <div class="">
      
      <div class="auth-form col-sm-4 mx-auto" style="margin-top:10%;">
        <h2 class="auth-title mb-5">Nouvelle Soumission</h2>
        <div class="p-5" v-if="isLoading">
          <fulfilling-bouncing-circle-spinner
            class="mx-auto"
            :animation-duration="2000"
            :size="60"
            :color="'#005C96'"
          />
        </div>
        <div v-else>
          <div class="alert alert-danger" v-if="errorMessage">
            {{ errorMessage }}
          </div>
          <form @submit="create">
            <div class="form-group">
              <label >Titre </label>
              <input type="text" class="form-control" v-model="newSubmission.title" required/>
            </div>

            <div class="form-group">
              <label >Résumé de l'article / la présentation </label>
              <textarea class="form-control" rows="4" v-model="newSubmission.summary" required></textarea>
            </div>

            <div class="row">
              <div class="col-sm-12" v-for="(file, i) in importFiles" :key="i">
                <div class="form-group">
                  <label for="photo">{{i == 0 ? 'Fichier principal' : 'Fichier ' + (i+1)}}</label>
                  <div :class="'custom-file' + (imageData[i] ? ' filled' : '')">
                    <div
                      class="img-preview"
                      :style="'background-image: url(' + imageData[i] + ')'"
                    ></div>
                    <input
                      type="file"
                      class="custom-file-input"
                      :id="'customFile' + i"
                      :ref="'file' + i"
                      @change="handleFileUpload(i)"
                    />
                    <label
                      class="custom-file-label"
                      :for="'customFile' + i"
                    >{{ file.name || 'Choisir un fichier'}}</label>
                  </div>
              </div>
              </div>
            </div>

            <div class="form-group">
              <input
                type="submit"
                class="btn btn-light btn-block"
                value="Soumettre"
              />
            </div>
          </form>
        </div>
      </div> 
    </div>
  </dashboard-layout>
</template>



<script>
export default {
  name: "Login",
  data() {
    return {
      newSubmission: {
        summary: "",
        title:"",
      },
      errorMessage: "",
      isLoading: false,

      importFiles: [],
      imageData: [],
      fileNumber: 1,
    };
  },
  mounted() {
    for (var i = 0; i < this.fileNumber; i++) {
      this.importFiles.push({});
      this.imageData.push("");
    }

    // navigator.geolocation.getCurrentPosition(position => {
    //   this.center = {
    //     latitude: position.coords.latitude,
    //     longitude: position.coords.longitude,
    //   };
    // });
  },
  methods: {
    create(e) {
      e.preventDefault();
      this.isLoading = true;
      
      this.newSubmission.date = new Date();
      this.newSubmission.author = localStorage.getItem('adminId')

      let formData = new FormData();
      formData.append("fileprop", "files");
      formData.append("filenumber", this.fileNumber);
      formData.append("objectdata", JSON.stringify(this.newSubmission));

      for (var i = 0; i < this.fileNumber; i++) {
        if (this.importFiles[i].name) {
          formData.append("filedata" + i, this.importFiles[i]);
        }
      }

      // console.log(formData.get('filedata0'))

      this.$service.createWithFile("submissions", formData, (err, data) => {
        this.isLoading = false;
        if (err) {
          this.errorMessage = err.data && err.data.message;
          console.log("Error", err.data);
          return;
        }

        if(data){
          this.$swal.fire("Soumission enregistrée !", "", "success").then(() => {
            this.$router.push({ path: "/" });  
          });
        }else{
          this.$swal.fire("Enregistrement échoué !", "", "danger").then(() => {
            this.$router.push({ path: "/" });  
          });
        }
        //console.log("retour de l api, create location ", data);
        
      });
    },

    handleFileUpload(index) {
      console.log(this.$refs["file" + index][0]);
      this.importFiles[index] = this.$refs["file" + index][0].files[0];
      if (this.importFiles[index]) {
        const reader = new FileReader();
        reader.onload = (e) => {
          this.imageData[index] = e.target.result;
          this.$forceUpdate();
        };
        reader.readAsDataURL(this.importFiles[index]);
      }
      this.$forceUpdate();
    },
  },
};
</script>
